Bug 655002 - Crash in NetworkManager trying to create invalid connection
Summary: Crash in NetworkManager trying to create invalid connection
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: NetworkManager
Version: 14
Hardware: Unspecified
OS: Unspecified
low
medium
Target Milestone: ---
Assignee: Dan Williams
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-11-19 10:29 UTC by Matthew Booth
Modified: 2011-04-12 21:28 UTC (History)
2 users (show)

Fixed In Version: NetworkManager-0.8.3.996-1.fc14
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2011-03-02 01:50:52 UTC


Attachments (Terms of Use)
Crashing test case (725 bytes, text/plain)
2010-11-19 10:29 UTC, Matthew Booth
no flags Details

Description Matthew Booth 2010-11-19 10:29:14 UTC
Created attachment 461512 [details]
Crashing test case

Description of problem:
I've attached a short ruby which attempts to create a connection with no ipv4 settings. It causes the NetworkManager daemon to crash immediately. I don't believe this specific case is a security issue as it requires the root password. I haven't tried it with NetworkManagerUserSettings, though (principally because I haven't reverse-engineered it enough to know how to use it yet).

<rant>As an aside, a much bigger issue is that all of this stuff is completely undocumented. It's all well and good to document an API that needs to be fed with arrays of hashes, but no good whatsoever if the required contents aren't documented anywhere. This particular case also highlights the fact that AddConnection doesn't seem to accept as input the data returned by ListConnections. I'm left to RTFS, and that's seriously opaque.</rant>

Version-Release number of selected component (if applicable):
NetworkManager-0.8.1-10.git20100831.fc14.x86_64

How reproducible:
Always

Steps to Reproduce:
1. Install the requirements of the ruby scripy (just ruby and ruby-dbus I think)
2. ./nm.rb

Comment 1 Jirka Klimes 2010-11-22 12:29:40 UTC
The bug has been fixed upstream since 30.9.2010:
http://cgit.freedesktop.org/NetworkManager/NetworkManager/commit/?id=088454fcab2a37b9c27d7bae0af2ebc1466d701f
http://cgit.freedesktop.org/NetworkManager/NetworkManager/commit/?h=NM_0_8&id=d841c6411fec90169a042c67d1894da7ac82ca5b

It should appear in Fedora shortly.

Adding connections to user settings via D-Bus in not supported at the moment.

As for documentation is concerned, it can always be better. Nevertheless these links should help:
* http://projects.gnome.org/NetworkManager/developers/spec-08.html
* http://live.gnome.org/NetworkManagerConfiguration
* http://cgit.freedesktop.org/NetworkManager/NetworkManager/tree/examples

Basically, the D-Bus API defines method arguments in D-Bus terms. It's hard to describe the exact syntax as each D-Bus language binding uses its own. See the third link for examples in Python and C.
If you are interested, contribute with some Ruby examples.

Comment 2 Matthew Booth 2010-11-22 14:08:42 UTC
Thanks for this, and thanks for the documentation links, although the first one was actually the one I was moaning about :) Interestingly, the python example seems to support a suspicion I have that this particular issue is a bug in the NetworkManager DBUS API itself. I'll file a separate BZ about that as and when I've convinced myself.

<apology>I'd like to apologise for ranting in a BZ. I realised within a few hours that it was an entirely inappropriate forum. Unfortunately I didn't realise this immediately after swearing at NetworkManager for a few hours. Thank you for being constructive, and not rising to it.</apology>

Comment 3 Fedora Update System 2011-02-24 06:06:16 UTC
NetworkManager-0.8.3.995-1.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/NetworkManager-0.8.3.995-1.fc14

Comment 4 Fedora Update System 2011-02-24 06:09:44 UTC
NetworkManager-0.8.3.995-1.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/NetworkManager-0.8.3.995-1.fc13

Comment 5 Fedora Update System 2011-02-24 20:57:27 UTC
NetworkManager-0.8.3.995-1.fc14 has been pushed to the Fedora 14 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update NetworkManager'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/NetworkManager-0.8.3.995-1.fc14

Comment 6 Fedora Update System 2011-02-25 23:43:04 UTC
Package NetworkManager-0.8.3.996-1.fc14:
* should fix your issue,
* was pushed to the Fedora 14 updates-testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing NetworkManager-0.8.3.996-1.fc14'
as soon as you are able to, then reboot.
Please go to the following url:
https://admin.fedoraproject.org/updates/NetworkManager-0.8.3.996-1.fc14
then log in and leave karma (feedback).

Comment 7 Fedora Update System 2011-02-25 23:46:04 UTC
Package NetworkManager-0.8.3.996-1.fc13:
* should fix your issue,
* was pushed to the Fedora 13 updates-testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing NetworkManager-0.8.3.996-1.fc13'
as soon as you are able to, then reboot.
Please go to the following url:
https://admin.fedoraproject.org/updates/NetworkManager-0.8.3.996-1.fc13
then log in and leave karma (feedback).

Comment 8 Fedora Update System 2011-03-02 01:49:26 UTC
NetworkManager-0.8.3.996-1.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 9 Fedora Update System 2011-03-03 09:47:34 UTC
Package NetworkManager-0.8.3.997-1.fc13:
* should fix your issue,
* was pushed to the Fedora 13 updates-testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing NetworkManager-0.8.3.997-1.fc13'
as soon as you are able to, then reboot.
Please go to the following url:
https://admin.fedoraproject.org/updates/NetworkManager-0.8.3.997-1.fc13
then log in and leave karma (feedback).

Comment 10 Fedora Update System 2011-03-25 03:30:30 UTC
NetworkManager-0.8.3.998-2.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/NetworkManager-0.8.3.998-2.fc13

Comment 11 Fedora Update System 2011-04-12 21:28:17 UTC
NetworkManager-0.8.3.998-2.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.